<template>
  <div id="bank-lecture-container">
    <div v-show="!isAdd">
      <h3>{{ $t('HEADER.LCT_BANK') }}</h3>
      <div
        v-if="!loading">
        <i class="el-icon-loading" style="font-size: 50px; float: left"></i>
      </div>
      <el-table
        ref="multipleTable"
        :data="bankLectureList"
        max-height="400">
        <el-table-column :label="$t('LECTURE_LIST.LECTURE_NAME')" prop="name" sortable>
          <template slot-scope="scope">{{ scope.row.name }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.GROUP')" width="200px" prop="name" sortable>
          <template slot-scope="scope">{{ scope.row.group_name }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.LECER_NAME')" width="200px" prop="name" sortable>
          <template slot-scope="scope">{{ scope.row.master_name }}</template>
        </el-table-column>
        <el-table-column :label="$t('TEACHER_CLASS.AFFILIATION')" width="200px" prop="name" sortable>
          <template slot-scope="scope">{{ scope.row.affiliation }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.CREATED')" width="200px" prop="date" sortable>
          <template slot-scope="scope">{{ scope.row.created_at }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.UPDATED')" width="200px" prop="date" sortable>
          <template slot-scope="scope">{{ scope.row.updated_at }}</template>
        </el-table-column>
        <!--<el-table-column label="저작일" width="120px">
          <template slot-scope="scope">{{ scope.row.createTime }}</template>
        </el-table-column>
        <el-table-column label="저장일" width="120px">
          <template slot-scope="scope">{{ scope.row.storeTime }}</template>
        </el-table-column>-->
        <el-table-column width="150px">
          <template slot-scope="scope">
            <el-button @click="onClick('DELETE_LECTURE', scope.row, scope)">{{ $t('BANK.ELIMINATE') }}</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div style="height: 10px;" />
      <el-button type="primary" @click="onClick('ADD_NEW_LECTURE')">{{ $t('BANK.IMPORT_LEC_FROM_CRS') }}</el-button>
    </div>
    <div v-show="isAdd">
      <h3>{{ $t('BANK.IMPORT_LEC_FROM_CRS') }}</h3>
      <el-button @click="onClick('BACK')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
      <div style="height: 10px;" />
      <el-tabs type="card" @tab-click="onClick('TAB_CHANGE')">
        <el-tab-pane :label="$t('ITEM_FROM_BANK.SRCH_LEC_NAME')">
          <el-input :placeholder="$t('ITEM_FROM_BANK.SRCH_LEC_NAME')" prefix-icon="el-icon-search" v-model="searchName" style="width: 300px;"></el-input>
          <el-button type="primary" @click="onClick('SEARCH_BY_NAME')">{{ $t('BANK.SEARCH') }}</el-button>
          <el-button @click="onClick('RESET_SEARCH')">{{ $t('BANK.RESET') }}</el-button>
        </el-tab-pane>
        <el-tab-pane :label="$t('ITEM_FROM_BANK.SRCH_CRS_NAME')">
          <el-input :placeholder="$t('ITEM_FROM_BANK.SRCH_CRS_NAME')" prefix-icon="el-icon-search" v-model="searchClass" style="width: 300px;"></el-input>
          <el-button type="primary" @click="onClick('SEARCH_BY_CLASS')">{{ $t('BANK.SEARCH') }}</el-button>
          <el-button @click="onClick('RESET_SEARCH')">{{ $t('BANK.RESET') }}</el-button>
        </el-tab-pane>
        <el-tab-pane :label="$t('ITEM_FROM_BANK.SEARCH_KEYWORD')">
          <el-input :placeholder="$t('BANK.SEARCH_KEYWORD')" prefix-icon="el-icon-search" v-model="searchKey" style="width: 300px;"></el-input>
          <el-button @click="onClick('NEW_KEYWORD', searchKey)">{{ $t('BANK.ADD_KEY') }}</el-button>
          <br />
          <div style="height: 10px;" />
          <el-tag v-for="(value, index) in searchKeywordList" :key="value" closable @close="deleteKeyword(index)" style="margin-right: 5px;">{{ value }}</el-tag>
          <el-button type="primary" @click="onClick('SEARCH_BY_KEYWORD')">{{ $t('BANK.SEARCH') }}</el-button>
          <el-button @click="onClick('RESET_SEARCH')">{{ $t('BANK.RESET') }}</el-button>
        </el-tab-pane>
      </el-tabs>
      <div style="height: 50px;" />
      <el-table ref="multipleTable" :data="resultLectureList" style="width: 100%" @selection-change="handleSelectionChange" max-height="400">
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column :label="$t('LECTURE_LIST.LECTURE_NAME')">
          <template slot-scope="scope">{{ scope.row.name }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.COURSE')">
          <template slot-scope="scope">{{ scope.row.class }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.CREATION_DATE')" width="200px">
          <template slot-scope="scope">{{ scope.row.createTime }}</template>
        </el-table-column>
        <el-table-column :label="$t('BANK.LATEST_EDIT')" width="200px">
          <template slot-scope="scope">{{ scope.row.updateTime }}</template>
        </el-table-column>
      </el-table>
      <div style="height: 10px;" />
      <el-select v-model="selectGroup" :placeholder="$t('DASHBOARD.GRP_ORD')">
        <el-option v-for="item in group" :key="item.group_id" :label="item.name" :value="item.group_id"></el-option>
      </el-select>
      <el-button type="primary" @click="saveLecture()">{{ $t('BANK.IMPORT_LEC_FROM_CRS') }}</el-button>
    </div>
  </div>
</template>

<script>
import bankService from '../../services/bankService';
import userService from '../../services/userService';

export default {
  name: 'BankLecture',
  data() {
    return {
      loading: false,
      searchName: '',
      searchKey: '',
      searchClass: '',
      selectGroup: '',
      isAdd: false,
      searchKeywordList: [],
      resultLectureList: [],
      myLectureList: [],
      group: [],
      multipleSelection: [],
      bankLectureList: [],
    };
  },
  async mounted() {
    const vm = this;
    vm.isAdd = false;
    // 은행의 강의들 받아오기
    const rew = await bankService.getBankLecture();
    rew.data.lectureList.forEach((xx) => {
      const bankLecture = {};
      bankLecture.id = xx.lecture_id;
      bankLecture.name = xx.name;
      bankLecture.group_id = xx.bank_group.group_id;
      bankLecture.group_name = xx.bank_group.name;
      bankLecture.latest_store_teacher_id = xx.latest_store_teacher_id;
      bankLecture.created_at = xx.created_at;
      bankLecture.updated_at = xx.updated_at;
      vm.bankLectureList.push(bankLecture);
    });
    // 강사명(master_id), 소속 기관(department_name) 넣기
    for(let i=0; i<rew.data.master_department.length; i++) {
      const mas_dept = rew.data.master_department[i];
      vm.bankLectureList[i].master_name = mas_dept.master_name;
      vm.bankLectureList[i].affiliation = mas_dept.affiliation;
    }

    // 내 강의들 받아오기 and 맛보기(시연) 과목은 은행에 저장 불가능
    const res = await bankService.getMyClassList();
    res.data.teachingClasses.forEach((x) => {
      if (parseInt(x.type, 10) !== 4) { // 시연과목이 아닌 경우만 리스트에 저장
        const classId = x.class_id;
        const cInfo = bankService.getClassInfo({
          id: classId,
        });
        cInfo.then(function(result) { // eslint-disable-line
          result.data.lectures.forEach((y) => {
            const lectureInfo = {};
            lectureInfo.name = y.name;
            const cr1 = y.created_at.substr(0, 10);
            const cr2 = y.created_at.substr(11, 8);
            lectureInfo.createTime = cr1.concat(' ', cr2);
            const up1 = y.updated_at.substr(0, 10);
            const up2 = y.updated_at.substr(11, 8);
            lectureInfo.updateTime = up1.concat(' ', up2);
            lectureInfo.class = result.data.name;
            lectureInfo.id = y.lecture_id;
            lectureInfo.key = [];
            y.lecture_keywords.forEach((z) => {
              lectureInfo.key.push(z.keyword);
            });
            /* 키워드까지 한번에 가져오게 백엔드 수정 190903
            const classKey = lectureService.getLectureKeywords({
              lectureId: y.lecture_id,
            });
            classKey.then(function(keyresult) { // eslint-disable-line
              keyresult.data.forEach((z) => {
                lectureInfo.key.push(z.keyword);
              });
            }); */
            vm.myLectureList.push(lectureInfo);
          });
        });
        vm.resultLectureList = vm.myLectureList;
      }
    });
    // 내 그룹 받아오기
    const myg = await bankService.getMyGroup();
    vm.group = myg.data.groupList;
    vm.loading = true;
  },
  methods: {
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    onClick(type, data) {
      const vm = this;
      switch (type) {
        // 강의를 저장소에 새로 저장하는 화면으로
        case 'ADD_NEW_LECTURE': {
          vm.isAdd = true;
          break;
        }
        // 강의저장소 목록으로 돌아가기
        case 'BACK': {
          vm.isAdd = false;
          location.reload(true);
          break;
        }
        // 탭 변경
        case 'TAB_CHANGE': {
          vm.searchName = '';
          vm.searchKey = '';
          vm.searchClass = '';
          vm.searchKeywordList = [];
          break;
        }
        // 강의명으로 검색
        case 'SEARCH_BY_NAME': {
          if (vm.searchName === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_CRS_NAME'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureList = [];
          vm.myLectureList.forEach((x) => {
            if (x.name.includes(vm.searchName)) {
              vm.resultLectureList.push(x);
            }
          });
          break;
        }
        // 과목명으로 검색
        case 'SEARCH_BY_CLASS': {
          if (vm.searchClass === '') {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ENTER_SUB_NAME'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureList = [];
          vm.myLectureList.forEach((x) => {
            if (x.class.includes(vm.searchClass)) {
              vm.resultLectureList.push(x);
            }
          });
          break;
        }
        // 검색할 키워드 추가
        case 'NEW_KEYWORD': {
          // 키워드 추가시 중복 검사
          if (vm.searchKeywordList.includes(vm.searchKey) === true) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ALRDY_ADDED_KEY'),
              type: 'warning',
            });
            break;
          }
          // 중복이 아닐 경우 검색 목록에 추가
          vm.searchKeywordList.push(vm.searchKey);
          vm.searchKey = '';
          break;
        }
        // 입력한 키워드들로 검색
        case 'SEARCH_BY_KEYWORD': {
          // 키워드가 없으면 검색이 되지 않음
          if (vm.searchKeywordList.length === 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ADD_KEY'),
              type: 'warning',
            });
            break;
          }
          vm.resultLectureList = [];
          vm.myLectureList.forEach((x) => {
            let ifContain = true;
            vm.searchKeywordList.forEach((y) => {
              if (x.key.includes(y) === false) {
                ifContain = false;
              }
            });
            if (ifContain === true) {
              vm.resultLectureList.push(x);
            }
          });
          break;
        }
        // 검색 결과 초기화
        case 'RESET_SEARCH': {
          vm.searchName = '';
          vm.searchKey = '';
          vm.searchClass = '';
          vm.searchKeywordList = [];
          vm.resultLectureList = vm.myLectureList;
          break;
        }
        // 은행에서 강의 삭제 190904
        case 'DELETE_LECTURE': {
          vm.loading = false;
          bankService.deleteBankLecture({
            id: data.id,
          });
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.CRS_DLT_FRM_BANK'),
            type: 'success',
          });
          // 프론트에서도 삭제
          const rowN = vm.bankLectureList.indexOf(data);
          vm.bankLectureList.splice(rowN, 1);
          vm.loading = true;
          break;
        }
        default: {
          break;
        }
      }
    },
    // 추가한 키워드 삭제
    deleteKeyword(arg) {
      const vm = this;
      vm.searchKeywordList.splice(arg, 1);
    },
    // 강의 저장하기
    saveLecture() {
      const vm = this;
      // 과목 선택을 안했을 경우
      if (vm.multipleSelection.length === 0) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('NOTIFY.SLCT_CRS_IN_BANK'),
          type: 'warning',
        });
        return;
      }
      // 그룹 선택을 안했을 경우
      if (vm.selectGroup === '') {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.t('NOTIFY.SLCT_GRP_SAV_CRS'),
          type: 'warning',
        });
        return;
      }
      vm.multipleSelection.forEach(async (x) => {
        const test = await bankService.saveLecture({
          lecture_id: x.id,
          group_id: vm.selectGroup,
        });
        // test찍기
        if (test.data.success === false) {
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.IPYNB_ITEM') + test.data.lectureName + vm.$t('NOTIFY.IPYNB_CRS') + test.data.itemName + vm.$t('NOTIFY.IPYNB_SAVED'),
            type: 'error',
          });          
        } else {
          vm.$notify({
            title: vm.$t('NOTIFY.TITLE'),
            message: vm.$t('NOTIFY.SUCCESS_SAV'),
            type: 'success',
          });
        }
      });
    },
  },
};
</script>